#include<bits/stdc++.h>

using namespace std;

long long p[75000];
long long np[75000];

int main () {
    int t;
    cin >> t;
    while(t--) {
        int n,m;
        cin >> n >> m;
        for(int i=0;i<n;i++) {
            cin >> p[i];
        }
        for(int i=0;i<m;i++) {
            cin >> np[i];
        }
        long long minx=1e19;
        sort(p, p+n);
        long long a1 = p[0];
        for(int i=0;i<n-1;i++) {
            p[i]=p[i+1]-p[i];
            if(p[i] < minx)
                minx=p[i];
        }
        bool ok = true;
        for(int i=0;i<n-1;i++) {
            if(p[i]%minx!=0) {
                cout << 0 << endl;
                ok = false;
                break;
            }
        }
        if(ok) {
            bool ok2 = true;
            for(int i=0;i<m;i++) {
                if((np[i]-a1)%minx==0) {
                    ok2 = false;
                    cout << 0 << endl;
                    break;
                }
            }
            if(ok2) {
                cout << 1 << endl;
            }
        }
    }
}